# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .email_address_email_address_type import EmailAddressEmailAddressType

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EmailAddress(pydantic.BaseModel):
    """
    # The EmailAddress Object

    ### Description

    The `EmailAddress` object is used to represent a candidate's email address.

    ### Usage Example

    Fetch from the `GET Candidate` endpoint and view their email addresses.
    """

    value: typing.Optional[str] = pydantic.Field(description="The email address.")
    email_address_type: typing.Optional[EmailAddressEmailAddressType] = pydantic.Field(
        description=(
            "The type of email address.\n" "\n" "- `PERSONAL` - PERSONAL\n" "- `WORK` - WORK\n" "- `OTHER` - OTHER\n"
        )
    )
    created_at: typing.Optional[dt.datetime]
    modified_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="This is the datetime that this object was last updated by Merge"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
