# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .account_details_and_actions_integration import AccountDetailsAndActionsIntegration
from .account_details_and_actions_status_enum import AccountDetailsAndActionsStatusEnum
from .category_enum import CategoryEnum

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AccountDetailsAndActions(pydantic.BaseModel):
    """
    # The LinkedAccount Object

    ### Description

    The `LinkedAccount` object is used to represent an end user's link with a specific integration.

    ### Usage Example

    View a list of your organization's `LinkedAccount` objects.
    """

    id: str
    category: typing.Optional[CategoryEnum]
    status: AccountDetailsAndActionsStatusEnum
    status_detail: typing.Optional[str]
    end_user_origin_id: typing.Optional[str]
    end_user_organization_name: str
    end_user_email_address: str
    webhook_listener_url: str
    is_duplicate: typing.Optional[bool] = pydantic.Field(
        description="Whether a Production Linked Account's credentials match another existing Production Linked Account. This field is `null` for Test Linked Accounts, incomplete Production Linked Accounts, and ignored duplicate Production Linked Account sets."
    )
    integration: typing.Optional[AccountDetailsAndActionsIntegration]
    account_type: str

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
